import { ErrorsCorrectionPageComponent } from './demo-models-page/errors-correction-page/errors-correction-page.component';
import { DashboardComponent } from './main-view/dashboard/dashboard.component';
import { SettingsComponent } from './main-view/settings/settings.component';
import { AnalysisStoryComponent } from './main-view/analysis-story/analysis-story.component';
import { PostAnalysisComponent } from './main-view/post-analysis/post-analysis.component';
import { AdvertAnalysisComponent } from './main-view/advert-analysis/advert-analysis.component';
import { MainViewComponent } from './main-view/main-view/main-view.component';
import { RegisterComponent } from './account/register/register.component';
import { LoginComponent } from './account/login/login.component';
import { HomePageComponent } from './home-page/home-page/home-page.component';
import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { SentimentAnalysisComponent } from './demo-models-page/sentiment-analysis/sentiment-analysis.component';
import { IronyAnalysisComponent } from './demo-models-page/irony-analysis/irony-analysis.component';
import { AdvertiseAnalysisComponent } from './demo-models-page/advertise-analysis/advertise-analysis.component';
import { FacebookAnalysisComponent } from './demo-models-page/facebook-analysis/facebook-analysis.component';

const routes: Routes = [
    { path: '', component: HomePageComponent },
    { path: 'login', component: LoginComponent },
    { path: 'register', component: RegisterComponent },
    { path: 'sentiment', component: SentimentAnalysisComponent },
    { path: 'errors', component: ErrorsCorrectionPageComponent },
    { path: 'irony', component: IronyAnalysisComponent },
    { path: 'advertise', component: AdvertiseAnalysisComponent},
    { path: 'post-analysis', component: FacebookAnalysisComponent},
    // {
    //     path: 'main-view', component: MainViewComponent, children: [
    //         { path: '', component: DashboardComponent },
    //         { path: 'ad-analysis', component: AdvertAnalysisComponent },
    //         { path: 'post-analysis', component: PostAnalysisComponent },
    //         { path: 'post-analysis/:id', component: PostAnalysisComponent },
    //         { path: 'history', component: AnalysisStoryComponent },
    //         { path: 'settings', component: SettingsComponent }
    //     ]
    // },

];

@NgModule({
    imports: [RouterModule.forRoot(routes)],
    exports: [RouterModule],
})
export class AppRoutingModule { }
