import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { HomePageComponent } from './home-page/home-page/home-page.component';
import { NavBarComponent } from './shared-components/nav-bar/nav-bar.component';
import { LoginComponent } from './account/login/login.component';
import { RegisterComponent } from './account/register/register.component';
import { MainViewComponent } from './main-view/main-view/main-view.component';
import {MatSidenavModule} from '@angular/material/sidenav';
import { HeaderComponent } from './shared-components/header/header.component';
import {MatToolbarModule} from '@angular/material/toolbar';
import { MatIconModule } from '@angular/material/icon';
import { AdvertAnalysisComponent } from './main-view/advert-analysis/advert-analysis.component';
import { PostAnalysisComponent } from './main-view/post-analysis/post-analysis.component';
import { AnalysisStoryComponent } from './main-view/analysis-story/analysis-story.component';
import { SettingsComponent } from './main-view/settings/settings.component';
import { MatTableModule } from '@angular/material/table';
import {MatTooltipModule} from '@angular/material/tooltip';
import { DashboardComponent } from './main-view/dashboard/dashboard.component';
import { NgChartsModule } from 'ng2-charts';
import { HttpClientModule } from '@angular/common/http';
import { SentimentAnalysisComponent } from './demo-models-page/sentiment-analysis/sentiment-analysis.component';
import { ReactiveFormsModule } from '@angular/forms';
import { ErrorsCorrectionPageComponent } from './demo-models-page/errors-correction-page/errors-correction-page.component';
import {MatProgressSpinnerModule} from '@angular/material/progress-spinner';
import { IronyAnalysisComponent } from './demo-models-page/irony-analysis/irony-analysis.component';
import { AdvertiseAnalysisComponent } from './demo-models-page/advertise-analysis/advertise-analysis.component';
import { FacebookAnalysisComponent } from './demo-models-page/facebook-analysis/facebook-analysis.component';

@NgModule({
  declarations: [
    AppComponent,
    HomePageComponent,
    NavBarComponent,
    LoginComponent,
    RegisterComponent,
    MainViewComponent,
    HeaderComponent,
    AdvertAnalysisComponent,
    PostAnalysisComponent,
    AnalysisStoryComponent,
    SettingsComponent,
    DashboardComponent,
    SentimentAnalysisComponent,
    ErrorsCorrectionPageComponent,
    IronyAnalysisComponent,
    AdvertiseAnalysisComponent,
    FacebookAnalysisComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    MatSidenavModule,
    BrowserAnimationsModule,
    MatToolbarModule,
    MatIconModule,
    MatTableModule,
    MatTooltipModule,
    NgChartsModule,
    HttpClientModule,
    ReactiveFormsModule,
    MatProgressSpinnerModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }
