import { HttpClient } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { FormArray, FormBuilder, FormGroup, Validators } from '@angular/forms';
import { Router } from '@angular/router';
import { Chart, ChartConfiguration, ChartOptions, ChartType } from 'chart.js';
import { environment } from 'src/environments/environment';

Chart.defaults.color = '#FFF';

@Component({
    selector: 'app-sentiment-analysis',
    templateUrl: './sentiment-analysis.component.html',
    styleUrls: ['./sentiment-analysis.component.scss']
})
export class SentimentAnalysisComponent implements OnInit {

    randomSampleList = [
        'Te słuchawki mają beznadziejną jakość dźwięku i wytrzymują tylko kilka tygodni.',
        'Ta pasta do zębów smakuje okropnie i nie zapewnia świeżego oddechu.',
        'Ta marka kawy jest okropna.',
        'Ten telefon ma strasznie krótką żywotność baterii i często się zawiesza.',
        'Te jeansy są strasznie niewygodne i źle uszyte.',
        'Ten odkurzacz nie zbiera kurzu skutecznie i ma zbyt krótki przewód.',
        'Ta książka obiecywała wiele, ale okazała się być nudna i przewidywalna.',
        'Ten krem do twarzy wywołał u mnie wysypkę i podrażnienie skóry.',
        'Ta herbata ma bardzo dziwny posmak i nie daje żadnej przyjemności.',
        'Ten telewizor ma wadliwy ekran i często się wyłącza.',
        'Ta lampa nie daje odpowiedniego oświetlenia i jest niewygodna w obsłudze.',
        'Ta szminka rozmazuje się i zostawia odciski na wszystkim, z czym się zetknę.',
        'Ten koc jest źle wykonany i nie utrzymuje ciepła.',
        'Ta pasta do polerowania samochodu nie daje żadnego efektu i tylko pozostawia smugi.',
        'Ten klimatyzator generuje ogromny hałas i zużywa dużo energii.',
        'Ta lodówka nie utrzymuje odpowiedniej temperatury i psuje jedzenie.',
        'Ten fotel biurowy jest nieergonomiczny i powoduje bóle pleców.',
        'Ta seria kosmetyków uczula mnie i powoduje wysypki na skórze.',
        'Ten blender ma słabą moc i nie radzi sobie z kruszeniem lodu.',
        'Ta torba na laptopa jest mało wytrzymała i szybko się rozpruwa.',
        'Te słuchawki mają doskonałą jakość dźwięku i są bardzo wytrzymałe.',
        'Ta pasta do zębów skutecznie odświeża oddech i pozostawia czyste i gładkie zęby.',
        'Ta marka kawy ma intensywny smak i bogate aromaty.',
        'Ten telefon ma długą żywotność baterii i działa płynnie bez żadnych zawieszeń.',
        'Te jeansy są wyjątkowo wygodne i świetnie dopasowane.',
        'Ten odkurzacz skutecznie zbiera kurz i ma długi przewód.',
        'Ta książka wciąga od pierwszej strony i dostarcza niezapomnianą przygodę.',
        'Ten krem do twarzy doskonale nawilża skórę i poprawia jej kondycję.',
        'Ta herbata ma wyjątkowy smak i pięknie pachnie.',
        'Ten telewizor ma doskonały obraz i liczne funkcje.',
        'Ta lampa zapewnia przyjemne i dostateczne oświetlenie, a także jest łatwa w obsłudze.',
        'Ta szminka jest trwała i nie rozmazuje się, pozostawiając piękny kolor na ustach.',
        'Ten koc jest miękki, przytulny i doskonale utrzymuje ciepło.',
        'Ten klimatyzator chłodzi pomieszczenie skutecznie i pracuje cicho.',
        'Ta lodówka utrzymuje stałą temperaturę i zachowuje świeżość jedzenia.',
        'Ten blender ma mocne ostrza i radzi sobie z kruszeniem lodu bez problemu.',
        'Ta torba na laptopa jest solidnie wykonana i zapewnia ochronę dla urządzenia.',
        'Ten koc jest zwykły i nie wyróżnia się niczym szczególnym.',
        'Ta książka jest typowa i nie wyróżnia się spośród innych powieści.',
        'Te jeansy są średnio wygodne i wykonane zwykłym standardem.',
        'Te słuchawki mają przeciętną jakość dźwięku i są trwałe.',
        'Ta herbata ma standardowy smak i nie jest ani wyjątkowa, ani wstrętna.',
        'Bardzo dobry produkt',
        'Nie spełnia moich oczekiwań',
        'Spodziewałem się że będzie źle, ale jest tragicznie',
        'Ma swoje wady i zalety ale może być',
        'Mogłobyć lepiej ale nie narzekam',
        'bardzo słaby produkt',
        'bardzo dobry produkt',
        'Dziś świeci słońce.',
        'bardzo słabo działa',
        'Jutro jest wtorek',
        'Zepsute słuchawki nie działają.',
        'Wspaniała suszarka, godna polecenia.',
        'Słońce jest żółte',
        'Ta klawiatura nie nadaje się do niczego',
        'Ta klawiatura jest wspaniała',
        "Ta lodówka ma pojemne wnętrze i wydajne chłodzenie.",
        "Telewizor jest wyposażony w ostry obraz i szerokie kąty widzenia.",
        "Ten samochód ma nowoczesne funkcje bezpieczeństwa i niskie zużycie paliwa.",
        "Suszarka do włosów jest lekka i łatwa w obsłudze.",
        "Ten zegarek ma solidną konstrukcję i precyzyjny mechanizm.",
        "Odkurzacz jest cichy i posiada skuteczną moc ssania.",
        "Ta kawa ma intensywny smak i aromatyczny zapach.",
        "Laptop jest wydajny i posiada długą żywotność baterii.",
        "Smartfon ma szybki procesor i czytelny wyświetlacz.",
        "Ten aparat fotograficzny ma dużą rozdzielczość i wiele trybów zdjęć.",
        "Mikrofalówka jest łatwa w czyszczeniu i ma wiele programów gotowania.",
        "Zestaw noży jest ostry i wygodny w użyciu.",
        "Ta lampa biurkowa ma regulację jasności i stabilne podstawki.",
        "Myszka komputerowa jest precyzyjna i wygodna w dłoni.",
        "Słuchawki douszne mają klarowny dźwięk i wygodne wkładki.",
        "Ten blender ma mocny silnik i łatwą obsługę.",
        "Zestaw garnków jest wykonany z solidnych materiałów i ma dobrą przewodność ciepła.",
        "Ta klawiatura komputerowa ma ergonomiczny układ klawiszy i podświetlenie.",
        "Prostownica do włosów jest szybka w nagrzewaniu i posiada regulację temperatury.",
        "Ten głośnik Bluetooth ma dobre brzmienie i stabilne połączenie."
    ]

    analysisStart = false;
    analysisLoading = false;
    results: { label: number, score: number, sentence: string }[] = [];
    error = false;
    public barChartLegend = true;
    public barChartPlugins = [];
    public barChartOptions: ChartConfiguration<'bar'>['options'] = {
        responsive: false,
        scales: {
            yAxes: {
                display: true,
            }
        }
    };
    public barChartData: ChartConfiguration<'bar'>['data'] = {
        labels: ['Statystyki'],
        datasets: []
    };

    sentimentForm: FormGroup = this.fb.group({
        sentences: this.fb.array([
            this.fb.group({
                text: ['', Validators.required]
            })
        ])
    })

    constructor(
        private fb: FormBuilder,
        private http: HttpClient,
        private router: Router
    ) { }

    get sentencesArray(): FormArray {
        return this.sentimentForm.controls['sentences'] as FormArray
    }


    ngOnInit(): void {
        //this.duplicateField()

    }

    analyzeSentiment(isRandomSample: boolean) {
        this.error = false
        this.analysisStart = true
        this.analysisLoading = false
        let sentences = []
        if (isRandomSample) {
            const shuffled = this.randomSampleList.sort(() => 0.5 - Math.random());
            sentences = shuffled.slice(0, 5);
        } else {
            let value = this.sentimentForm.value
            sentences = value.sentences.map((value: any) => value.text)
        }
        this.http.post(environment.sentiment, { sentences: sentences }).subscribe({
            next: (resp: any) => {
                this.results = resp.predictions
                console.log(resp)
                this.barChartData.datasets = [
                    { data: [resp.count_labels.negative], label: String(resp.count_labels.negative) + ' negatywny', backgroundColor: 'rgba(250, 66, 66, 1)', borderRadius: 15, },
                    { data: [resp.count_labels.positive], label: String(resp.count_labels.positive) + ' pozytywny', backgroundColor: '#65dec2', borderRadius: 15, },
                    { data: [resp.count_labels.neutral], label: String(resp.count_labels.neutral) + ' neutralny', backgroundColor: 'rgb(196, 196, 196)', borderRadius: 15, }
                ]
                this.analysisLoading = true
                // this.sentencesArray.clear()
                // setTimeout(() => {
                //     this.duplicateField()
                // }, 50)
            },
            error: () => {
                this.analysisLoading = true
                this.error = true
                console.log('error')
            }
        })
    }

    duplicateField() {
        const sentenceForm = this.fb.group({
            text: ['', Validators.required]
        })
        this.sentencesArray.push(sentenceForm)
    }

    trackByFn(index: any, item: any) {
        return index;
    }

    goToMainPage() {
        this.router.navigate([''])
    }

    resetFields() {
        this.sentencesArray.clear()
        setTimeout(() => {
            this.duplicateField()
        }, 10)
    }

}
