import { HttpClient, HttpParams } from '@angular/common/http';
import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { Observable } from 'rxjs';

@Component({
    selector: 'app-home-page',
    templateUrl: './home-page.component.html',
    styleUrls: ['./home-page.component.scss']
})
export class HomePageComponent implements OnInit {

    wixa = false;
    constructor(
        private http: HttpClient,
        private router: Router
    ) { }

    ngOnInit(): void {
    }

    goToSentiment() {
        this.router.navigate(['/sentiment'])
    }

    goToErrors() {
        this.router.navigate(['/errors'])
    }

    goToIrony() {
        this.router.navigate(['/irony'])
    }

    goToAdvert() {
        this.router.navigate(['/advertise'])
    }

    goToFacebook() {
        this.router.navigate(['/post-analysis'])
    }

    scrollDown(): void {
        window.scrollTo({ top: document.body.clientHeight, behavior: "smooth", });
    }

    runWixa(): void {
        this.wixa = !this.wixa
        setTimeout(() => {
            location.reload()
        }, 1500);
    }

}
