import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';

export interface AnalysisStoryInterface {
    id: number;
    postUrl: string;
    isPositive: boolean;
};

@Component({
    selector: 'app-analysis-story',
    templateUrl: './analysis-story.component.html',
    styleUrls: ['./analysis-story.component.scss']
})
export class AnalysisStoryComponent implements OnInit {

    analysisStory: AnalysisStoryInterface[] = [
        {
            id: 0,
            postUrl: 'https://www.facebook.com/rtveuroagd/posts/pfbid02Jr4girzeaB9UdEj2V78RSzp2inkhaY3kxsmdtNitMVzq3A9WnBBzsYDeWhK5HNx5l',
            isPositive: true
        },
        {
            id: 1,
            postUrl: 'https://www.facebook.com/rtveuroagd/posts/pfbid02UTh3KgftpyaMqmXSM8XyVDnbCzT2uay4d99TQWNUb2XgWD21beEhy4g6BYesLBKCl',
            isPositive: false
        },
    ]
    displayedColumns: string[] = ['link', 'result', 'action'];

    constructor(private router: Router, private route: ActivatedRoute,) { }

    ngOnInit(): void {}

    navigateToAnalysis(analysisId: number) {
        this.router.navigate(['/main-view/post-analysis', analysisId])
    }

}
