import { Router } from '@angular/router';
import { Component, OnInit } from '@angular/core';

export interface DashboardElements {
    name: string;
    route: string;
    icon:string;
}

@Component({
    selector: 'app-dashboard',
    templateUrl: './dashboard.component.html',
    styleUrls: ['./dashboard.component.scss']
})

export class DashboardComponent implements OnInit {

    constructor(private router:Router) { }

    dashboardElements:DashboardElements[]=[
        {
            name:'Analiza tekstu reklamy',
            route: '/main-view/ad-analysis',
            icon: 'textsms',
        },
        {
            name:'Analiza posta',
            route: '/main-view/post-analysis',
            icon: 'find_in_page',
        },
        {
            name:'Historia twoich analiz',
            route: '/main-view/history',
            icon: 'history',
        },
        {
            name:'Ustawienia konta',
            route: '/main-view/settings',
            icon: 'account_circle',
        }
    ]

    ngOnInit(): void {
    }

    navigate(route:string){
        this.router.navigate([route])
    }

}
