import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';

@Component({
    selector: 'app-main-view',
    templateUrl: './main-view.component.html',
    styleUrls: ['./main-view.component.scss']
})
export class MainViewComponent implements OnInit {

    activePage: number = 0

    menuConfig: { name: string, icon: string, route: string }[] = [
        {
            name: 'Analiza tekstu reklamy',
            icon: 'textsms',
            route: '/main-view/ad-analysis',
        }, {
            name: 'Analiza posta',
            icon: 'find_in_page',
            route: '/main-view/post-analysis',
        }, {
            name: 'Historia twoich analiz',
            icon: 'history',
            route: '/main-view/history',
        }, {
            name: 'Ustawienia konta',
            icon: 'account_circle',
            route: '/main-view/settings',
        }
    ]

    constructor(
        public router:Router
    ) { }

    ngOnInit(): void {
    }

    route(index:number){
        this.activePage = index
        this.router.navigate([this.menuConfig[index].route])
    }

}
